#!/bin/bash
 
A=$(docker inspect --format='{{range .NetworkSettings.Networks}}{{.IPAddress}}{{end}}' party0) 
B=$(docker inspect --format='{{range .NetworkSettings.Networks}}{{.IPAddress}}{{end}}' party1) 
echo $A
echo $B
docker exec -w /root/duoram/2p-preprocessing party1 ./preprocessing1  $A 10 10 &
sleep 2
echo "P1 launched"
docker exec -w /root/duoram/2p-preprocessing party0 ./preprocessing0  $B 10 10 &
echo "P0 launched"
wait
